import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _extends from "@babel/runtime/helpers/extends";
import React, { Component, PureComponent, createElement, createContext, forwardRef } from 'react';
import ReactDOM from 'react-dom';
import { adapter, pageRendererFactory, componentRendererFactory, blockRendererFactory, addonRendererFactory, tempRendererFactory, rendererFactory, types } from '@alilc/lowcode-renderer-core';
import ConfigProvider from '@alifd/next/lib/config-provider';
import { buildComponents } from './utils';
import * as vueRendererExtTypes from './types';
window.React = React;
window.ReactDom = ReactDOM;
var defaultRuntime = {
  Component: Component,
  PureComponent: PureComponent,
  createContext: createContext,
  createElement: createElement,
  forwardRef: forwardRef,
  findDOMNode: ReactDOM.findDOMNode
};
adapter.setRuntime(defaultRuntime);

function setRuntime(runtime) {
  adapter.setRuntime(_extends({}, defaultRuntime, runtime));
}

var defaultRenderers = {
  PageRenderer: pageRendererFactory(),
  ComponentRenderer: componentRendererFactory(),
  BlockRenderer: blockRendererFactory(),
  AddonRenderer: addonRendererFactory(),
  TempRenderer: tempRendererFactory(),
  DivRenderer: blockRendererFactory()
};
adapter.setRenderers(defaultRenderers);

function setRenderers(renderers) {
  adapter.setRenderers(_extends({}, defaultRenderers, renderers));
}

var defaultConfigProvider = ConfigProvider;
adapter.setConfigProvider(defaultConfigProvider);

function setConfigProvider(configProvide) {
  adapter.setConfigProvider(configProvide);
}

function createRendererFactory() {
  var Renderer = rendererFactory();
  return /*#__PURE__*/function (_Renderer) {
    _inheritsLoose(ReactRenderer, _Renderer);

    function ReactRenderer(props, context) {
      return _Renderer.call(this, props, context) || this;
    }

    var _proto = ReactRenderer.prototype;

    _proto.isValidComponent = function isValidComponent(obj) {
      var _obj$prototype;

      return (obj === null || obj === void 0 ? void 0 : (_obj$prototype = obj.prototype) === null || _obj$prototype === void 0 ? void 0 : _obj$prototype.isReactComponent) || (obj === null || obj === void 0 ? void 0 : obj.prototype) instanceof Component;
    };

    return ReactRenderer;
  }(Renderer);
}

export default createRendererFactory;
export { setRuntime, setRenderers, setConfigProvider, buildComponents, types, vueRendererExtTypes };