"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;
exports.setConfigProvider = setConfigProvider;
exports.setRenderers = setRenderers;
exports.setRuntime = setRuntime;
exports.vueRendererExtTypes = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _lowcodeRendererCore = require("@alilc/lowcode-renderer-core");

exports.types = _lowcodeRendererCore.types;

var _configProvider = _interopRequireDefault(require("@alifd/next/lib/config-provider"));

var _utils = require("./utils");

exports.buildComponents = _utils.buildComponents;

var vueRendererExtTypes = _interopRequireWildcard(require("./types"));

exports.vueRendererExtTypes = vueRendererExtTypes;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

window.React = _react["default"];
window.ReactDom = _reactDom["default"];
var defaultRuntime = {
  Component: _react.Component,
  PureComponent: _react.PureComponent,
  createContext: _react.createContext,
  createElement: _react.createElement,
  forwardRef: _react.forwardRef,
  findDOMNode: _reactDom["default"].findDOMNode
};

_lowcodeRendererCore.adapter.setRuntime(defaultRuntime);

function setRuntime(runtime) {
  _lowcodeRendererCore.adapter.setRuntime((0, _extends2["default"])({}, defaultRuntime, runtime));
}

var defaultRenderers = {
  PageRenderer: (0, _lowcodeRendererCore.pageRendererFactory)(),
  ComponentRenderer: (0, _lowcodeRendererCore.componentRendererFactory)(),
  BlockRenderer: (0, _lowcodeRendererCore.blockRendererFactory)(),
  AddonRenderer: (0, _lowcodeRendererCore.addonRendererFactory)(),
  TempRenderer: (0, _lowcodeRendererCore.tempRendererFactory)(),
  DivRenderer: (0, _lowcodeRendererCore.blockRendererFactory)()
};

_lowcodeRendererCore.adapter.setRenderers(defaultRenderers);

function setRenderers(renderers) {
  _lowcodeRendererCore.adapter.setRenderers((0, _extends2["default"])({}, defaultRenderers, renderers));
}

var defaultConfigProvider = _configProvider["default"];

_lowcodeRendererCore.adapter.setConfigProvider(defaultConfigProvider);

function setConfigProvider(configProvide) {
  _lowcodeRendererCore.adapter.setConfigProvider(configProvide);
}

function createRendererFactory() {
  var Renderer = (0, _lowcodeRendererCore.rendererFactory)();
  return /*#__PURE__*/function (_Renderer) {
    (0, _inheritsLoose2["default"])(ReactRenderer, _Renderer);

    function ReactRenderer(props, context) {
      return _Renderer.call(this, props, context) || this;
    }

    var _proto = ReactRenderer.prototype;

    _proto.isValidComponent = function isValidComponent(obj) {
      var _obj$prototype;

      return (obj === null || obj === void 0 ? void 0 : (_obj$prototype = obj.prototype) === null || _obj$prototype === void 0 ? void 0 : _obj$prototype.isReactComponent) || (obj === null || obj === void 0 ? void 0 : obj.prototype) instanceof _react.Component;
    };

    return ReactRenderer;
  }(Renderer);
}

var _default = createRendererFactory;
exports["default"] = _default;