"use strict";

exports.__esModule = true;
exports.isReactClass = isReactClass;
exports.isReactComponent = isReactComponent;

var _react = require("react");

var hasSymbol = typeof Symbol === 'function' && Symbol["for"];
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol["for"]('react.forward_ref') : 0xead0;

function isReactClass(obj) {
  return obj && obj.prototype && (obj.prototype.isReactComponent || obj.prototype instanceof _react.Component);
}

function isForwardRefType(obj) {
  return (obj === null || obj === void 0 ? void 0 : obj.$$typeof) && (obj === null || obj === void 0 ? void 0 : obj.$$typeof) === REACT_FORWARD_REF_TYPE;
}

function isReactComponent(obj) {
  return obj && (isReactClass(obj) || isForwardRefType(obj));
}